(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@yukawa/chain-base-angular-client'), require('@yukawa/chain-base-angular-domain')) :
    typeof define === 'function' && define.amd ? define('@yukawa/chain-main-angular-core', ['exports', '@yukawa/chain-base-angular-client', '@yukawa/chain-base-angular-domain'], factory) :
    (global = global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa['chain-main-angular-core'] = {}), global.chainBaseAngularClient, global.chainBaseAngularDomain));
}(this, (function (exports, chainBaseAngularClient, chainBaseAngularDomain) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.group.Group <br/>
     * @record
     */
    function Group() { }
    if (false) {
        /** @type {?|undefined} */
        Group.prototype.change;
        /** @type {?|undefined} */
        Group.prototype.created;
        /** @type {?|undefined} */
        Group.prototype.info;
        /**
         * \@example users
         * @type {?|undefined}
         */
        Group.prototype.name;
        /**
         * \@example YUK
         * @type {?|undefined}
         */
        Group.prototype.orgId;
        /**
         * \@example all
         * @type {?|undefined}
         */
        Group.prototype.parentId;
        /** @type {?|undefined} */
        Group.prototype.roles;
        /**
         * \@example sys
         * @type {?|undefined}
         */
        Group.prototype.type;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.group.GroupFilter <br/>
     * @record
     */
    function GroupFilter() { }
    if (false) {
        /**
         * \@example ADMINS
         * @type {?|undefined}
         */
        GroupFilter.prototype.groupName;
        /** @type {?|undefined} */
        GroupFilter.prototype.orgId;
        /**
         * \@example all
         * @type {?|undefined}
         */
        GroupFilter.prototype.parentId;
        /**
         * \@example system
         * @type {?|undefined}
         */
        GroupFilter.prototype.type;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.group.Membership <br/>
     * @record
     */
    function Membership() { }
    if (false) {
        /**
         * \@example users
         * @type {?|undefined}
         */
        Membership.prototype.groupName;
        /**
         * \@example users
         * @type {?|undefined}
         */
        Membership.prototype.orgId;
        /** @type {?|undefined} */
        Membership.prototype.usernames;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.org.Org <br/>
     * @record
     */
    function Org() { }
    if (false) {
        /** @type {?|undefined} */
        Org.prototype.addresses;
        /** @type {?|undefined} */
        Org.prototype.change;
        /**
         * \@example Yukawa Systems GmbH
         * @type {?|undefined}
         */
        Org.prototype.companyName;
        /** @type {?|undefined} */
        Org.prototype.created;
        /**
         * \@example yukawa\@example.com
         * @type {?|undefined}
         */
        Org.prototype.email;
        /** @type {?|undefined} */
        Org.prototype.info;
        /**
         * \@example YUK
         * @type {?|undefined}
         */
        Org.prototype.orgId;
        /**
         * \@example +49 100 200 300
         * @type {?|undefined}
         */
        Org.prototype.phoneNumber;
        /**
         * \@example DE113344
         * @type {?|undefined}
         */
        Org.prototype.taxId;
        /**
         * \@example http://yukawa.de/
         * @type {?|undefined}
         */
        Org.prototype.website;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.org.OrgFilter <br/>
     * @record
     */
    function OrgFilter() { }
    if (false) {
        /** @type {?|undefined} */
        OrgFilter.prototype.addressFilter;
        /** @type {?|undefined} */
        OrgFilter.prototype.companyName;
        /** @type {?|undefined} */
        OrgFilter.prototype.email;
        /** @type {?|undefined} */
        OrgFilter.prototype.phoneNumber;
        /**
         * \@example DE113344
         * @type {?|undefined}
         */
        OrgFilter.prototype.taxId;
        /** @type {?|undefined} */
        OrgFilter.prototype.website;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.setting.Setting <br/>
     * @record
     */
    function Setting() { }
    if (false) {
        /** @type {?|undefined} */
        Setting.prototype.change;
        /**
         * \@example default central storage location
         * @type {?|undefined}
         */
        Setting.prototype.desc;
        /**
         * \@example main
         * @type {?|undefined}
         */
        Setting.prototype.module;
        /**
         * \@example Central Storage Location
         * @type {?|undefined}
         */
        Setting.prototype.name;
        /**
         * \@example YUK
         * @type {?|undefined}
         */
        Setting.prototype.orgId;
        /**
         * \@example storage.location.central
         * @type {?|undefined}
         */
        Setting.prototype.shortName;
        /**
         * \@example 1337
         * @type {?|undefined}
         */
        Setting.prototype.value;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.setting.SettingFilter <br/>
     * @record
     */
    function SettingFilter() { }
    if (false) {
        /**
         * \@example stock
         * @type {?|undefined}
         */
        SettingFilter.prototype.module;
        /**
         * \@example storage*
         * @type {?|undefined}
         */
        SettingFilter.prototype.shortName;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.Tag <br/>
     * @record
     */
    function Tag() { }
    if (false) {
        /** @type {?|undefined} */
        Tag.prototype.change;
        /** @type {?|undefined} */
        Tag.prototype.info;
        /** @type {?|undefined} */
        Tag.prototype.key;
        /**
         * \@example YUK
         * @type {?|undefined}
         */
        Tag.prototype.orgId;
        /** @type {?|undefined} */
        Tag.prototype.tagId;
        /** @type {?|undefined} */
        Tag.prototype.vocabularyId;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.TagFilter <br/>
     * @record
     */
    function TagFilter() { }
    /**
     * \@generator rest2ts
     * 	tag vocabulary <br/>
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.Vocabulary <br/>
     * @record
     */
    function Vocabulary() { }
    if (false) {
        /** @type {?|undefined} */
        Vocabulary.prototype.key;
        /** @type {?|undefined} */
        Vocabulary.prototype.vocabularyId;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.user.GroupContext <br/>
     * @record
     */
    function GroupContext() { }
    if (false) {
        /** @type {?|undefined} */
        GroupContext.prototype.groups;
        /** @type {?|undefined} */
        GroupContext.prototype.orgId;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.user.User <br/>
     * @record
     */
    function User() { }
    if (false) {
        /** @type {?|undefined} */
        User.prototype.account;
        /** @type {?|undefined} */
        User.prototype.change;
        /** @type {?|undefined} */
        User.prototype.created;
        /** @type {?|undefined} */
        User.prototype.defaultOrgId;
        /** @type {?|undefined} */
        User.prototype.groupContexts;
        /**
         * @deprecated
         * @type {?|undefined}
         */
        User.prototype.groups;
        /** @type {?|undefined} */
        User.prototype.orgIds;
        /** @type {?|undefined} */
        User.prototype.person;
        /**
         * \@example admin
         * @type {?|undefined}
         */
        User.prototype.username;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.user.UserFilter <br/>
     * @record
     */
    function UserFilter() { }
    if (false) {
        /** @type {?|undefined} */
        UserFilter.prototype.defaultOrgId;
        /** @type {?|undefined} */
        UserFilter.prototype.fields;
        /** @type {?|undefined} */
        UserFilter.prototype.groups;
        /** @type {?|undefined} */
        UserFilter.prototype.headers;
        /** @type {?|undefined} */
        UserFilter.prototype.orgIds;
        /** @type {?|undefined} */
        UserFilter.prototype.personFilter;
        /**
         * \@example admin
         * @type {?|undefined}
         */
        UserFilter.prototype.username;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.event.user.UserEvent <br/>
     * @record
     */
    function UserEvent() { }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UrlService = /** @class */ (function (_super) {
        __extends(UrlService, _super);
        function UrlService(configService, cfg) {
            if (cfg === void 0) { cfg = "baseUrl"; }
            return _super.call(this, cfg, configService) || this;
        }
        return UrlService;
    }(chainBaseAngularClient.UrlConfigService));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // noinspection JSUnusedGlobalSymbols
    /**
     * inc.yukawa.chain.modules.main.core.MainRealm
     * \@since 2.0.7
     *
     */
    var MainRealm = /** @class */ (function (_super) {
        __extends(MainRealm, _super);
        function MainRealm() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MainRealm.ROLE_MAIN_ADMIN = "ROLE_MAIN_ADMIN";
        MainRealm.ROLE_MAIN_EDIT = "ROLE_MAIN_EDIT";
        MainRealm.ROLE_MAIN_READ = "ROLE_MAIN_READ";
        MainRealm.ROLE_SYS_INFO = "ROLE_SYS_INFO";
        MainRealm.ROLE_USER_ADMIN = "ROLE_USER_ADMIN";
        MainRealm.ROLE_USER_EDIT = "ROLE_USER_EDIT";
        MainRealm.ROLE_USER_READ = "ROLE_USER_READ";
        MainRealm.ROLE_USER_INFO = "ROLE_USER_INFO";
        MainRealm.ROLE_USER_OWN = "ROLE_USER_OWN";
        MainRealm.ROLE_GROUP_ADMIN = "ROLE_GROUP_ADMIN";
        MainRealm.ROLE_GROUP_EDIT = "ROLE_GROUP_EDIT";
        MainRealm.ROLE_GROUP_READ = "ROLE_GROUP_READ";
        MainRealm.ROLE_MEMBERSHIP_ADMIN = "ROLE_MEMBERSHIP_ADMIN";
        MainRealm.ROLE_MEMBERSHIP_EDIT = "ROLE_MEMBERSHIP_EDIT";
        MainRealm.ROLE_MEMBERSHIP_READ = "ROLE_MEMBERSHIP_READ";
        MainRealm.ROLE_LABEL_ADMIN = "ROLE_LABEL_ADMIN";
        MainRealm.ROLE_LABEL_EDIT = "ROLE_LABEL_EDIT";
        MainRealm.ROLE_LABEL_READ = "ROLE_LABEL_READ";
        MainRealm.ROLE_ORG_ADMIN = "ROLE_ORG_ADMIN";
        MainRealm.ROLE_ORG_EDIT = "ROLE_ORG_EDIT";
        MainRealm.ROLE_ORG_READ = "ROLE_ORG_READ";
        MainRealm.ROLE_ORG_INFO = "ROLE_ORG_INFO";
        MainRealm.ROLE_ROLE_ADMIN = "ROLE_ROLE_ADMIN";
        MainRealm.ROLE_ROLE_EDIT = "ROLE_ROLE_EDIT";
        MainRealm.ROLE_ROLE_READ = "ROLE_ROLE_READ";
        MainRealm.ROLE_SETTING_ADMIN = "ROLE_SETTING_ADMIN";
        MainRealm.ROLE_SETTING_EDIT = "ROLE_SETTING_EDIT";
        MainRealm.ROLE_SETTING_READ = "ROLE_SETTING_READ";
        MainRealm.ROLE_TAG_ADMIN = "ROLE_TAG_ADMIN";
        MainRealm.ROLE_TAG_EDIT = "ROLE_TAG_EDIT";
        MainRealm.ROLE_TAG_READ = "ROLE_TAG_READ";
        return MainRealm;
    }(chainBaseAngularDomain.BaseRealm));
    if (false) {
        /** @type {?} */
        MainRealm.ROLE_MAIN_ADMIN;
        /** @type {?} */
        MainRealm.ROLE_MAIN_EDIT;
        /** @type {?} */
        MainRealm.ROLE_MAIN_READ;
        /** @type {?} */
        MainRealm.ROLE_SYS_INFO;
        /** @type {?} */
        MainRealm.ROLE_USER_ADMIN;
        /** @type {?} */
        MainRealm.ROLE_USER_EDIT;
        /** @type {?} */
        MainRealm.ROLE_USER_READ;
        /** @type {?} */
        MainRealm.ROLE_USER_INFO;
        /** @type {?} */
        MainRealm.ROLE_USER_OWN;
        /** @type {?} */
        MainRealm.ROLE_GROUP_ADMIN;
        /** @type {?} */
        MainRealm.ROLE_GROUP_EDIT;
        /** @type {?} */
        MainRealm.ROLE_GROUP_READ;
        /** @type {?} */
        MainRealm.ROLE_MEMBERSHIP_ADMIN;
        /** @type {?} */
        MainRealm.ROLE_MEMBERSHIP_EDIT;
        /** @type {?} */
        MainRealm.ROLE_MEMBERSHIP_READ;
        /** @type {?} */
        MainRealm.ROLE_LABEL_ADMIN;
        /** @type {?} */
        MainRealm.ROLE_LABEL_EDIT;
        /** @type {?} */
        MainRealm.ROLE_LABEL_READ;
        /** @type {?} */
        MainRealm.ROLE_ORG_ADMIN;
        /** @type {?} */
        MainRealm.ROLE_ORG_EDIT;
        /** @type {?} */
        MainRealm.ROLE_ORG_READ;
        /** @type {?} */
        MainRealm.ROLE_ORG_INFO;
        /** @type {?} */
        MainRealm.ROLE_ROLE_ADMIN;
        /** @type {?} */
        MainRealm.ROLE_ROLE_EDIT;
        /** @type {?} */
        MainRealm.ROLE_ROLE_READ;
        /** @type {?} */
        MainRealm.ROLE_SETTING_ADMIN;
        /** @type {?} */
        MainRealm.ROLE_SETTING_EDIT;
        /** @type {?} */
        MainRealm.ROLE_SETTING_READ;
        /** @type {?} */
        MainRealm.ROLE_TAG_ADMIN;
        /** @type {?} */
        MainRealm.ROLE_TAG_EDIT;
        /** @type {?} */
        MainRealm.ROLE_TAG_READ;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function GroupAspect() { }
    if (false) {
        /**
         * @param {?} filter
         * @return {?}
         */
        GroupAspect.prototype.queryGroups = function (filter) { };
        /**
         * @param {?} key
         * @return {?}
         */
        GroupAspect.prototype.loadGroup = function (key) { };
        /**
         * @param {?} value
         * @return {?}
         */
        GroupAspect.prototype.createGroup = function (value) { };
        /**
         * @param {?} value
         * @return {?}
         */
        GroupAspect.prototype.editGroup = function (value) { };
        /**
         * @param {?} key
         * @return {?}
         */
        GroupAspect.prototype.deleteGroup = function (key) { };
    }
    /**
     * @record
     */
    function UserAspect() { }
    if (false) {
        /**
         * @deprecated
         * @param {?} filter
         * @return {?}
         */
        UserAspect.prototype.searchUser = function (filter) { };
        /**
         * @param {?} filter
         * @return {?}
         */
        UserAspect.prototype.queryUser = function (filter) { };
        /**
         * @param {?} id
         * @param {?} shortName
         * @return {?}
         */
        UserAspect.prototype.loadUser = function (id, shortName) { };
        /**
         * @param {?} user
         * @param {?} method
         * @return {?}
         */
        UserAspect.prototype.saveUser = function (user, method) { };
        /**
         * @param {?} id
         * @return {?}
         */
        UserAspect.prototype.deleteUser = function (id) { };
    }
    /**
     * @record
     */
    function LabelAspect() { }
    if (false) {
        /**
         * @param {?} filter
         * @return {?}
         */
        LabelAspect.prototype.findLabels = function (filter) { };
        /**
         * @param {?} filter
         * @return {?}
         */
        LabelAspect.prototype.queryLabel = function (filter) { };
        /**
         * @param {?} label
         * @return {?}
         */
        LabelAspect.prototype.createLabel = function (label) { };
    }
    /**
     * @record
     */
    function SettingAspect() { }
    if (false) {
        /**
         * @param {?} filter
         * @return {?}
         */
        SettingAspect.prototype.querySettings = function (filter) { };
        /**
         * @param {?} module
         * @param {?} shortName
         * @return {?}
         */
        SettingAspect.prototype.loadSetting = function (module, shortName) { };
        /**
         * @param {?} Setting
         * @return {?}
         */
        SettingAspect.prototype.editSetting = function (Setting) { };
        /**
         * @param {?} module
         * @param {?} shortName
         * @return {?}
         */
        SettingAspect.prototype.deleteSetting = function (module, shortName) { };
    }

    exports.MainRealm = MainRealm;
    exports.UrlService = UrlService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=yukawa-chain-main-angular-core.umd.js.map
