import { __extends } from 'tslib';
import { UrlConfigService } from '@yukawa/chain-base-angular-client';
import { BaseRealm } from '@yukawa/chain-base-angular-domain';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.group.Group <br/>
 * @record
 */
function Group() { }
if (false) {
    /** @type {?|undefined} */
    Group.prototype.change;
    /** @type {?|undefined} */
    Group.prototype.created;
    /** @type {?|undefined} */
    Group.prototype.info;
    /**
     * \@example users
     * @type {?|undefined}
     */
    Group.prototype.name;
    /**
     * \@example YUK
     * @type {?|undefined}
     */
    Group.prototype.orgId;
    /**
     * \@example all
     * @type {?|undefined}
     */
    Group.prototype.parentId;
    /** @type {?|undefined} */
    Group.prototype.roles;
    /**
     * \@example sys
     * @type {?|undefined}
     */
    Group.prototype.type;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.group.GroupFilter <br/>
 * @record
 */
function GroupFilter() { }
if (false) {
    /**
     * \@example ADMINS
     * @type {?|undefined}
     */
    GroupFilter.prototype.groupName;
    /** @type {?|undefined} */
    GroupFilter.prototype.orgId;
    /**
     * \@example all
     * @type {?|undefined}
     */
    GroupFilter.prototype.parentId;
    /**
     * \@example system
     * @type {?|undefined}
     */
    GroupFilter.prototype.type;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.group.Membership <br/>
 * @record
 */
function Membership() { }
if (false) {
    /**
     * \@example users
     * @type {?|undefined}
     */
    Membership.prototype.groupName;
    /**
     * \@example users
     * @type {?|undefined}
     */
    Membership.prototype.orgId;
    /** @type {?|undefined} */
    Membership.prototype.usernames;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.org.Org <br/>
 * @record
 */
function Org() { }
if (false) {
    /** @type {?|undefined} */
    Org.prototype.addresses;
    /** @type {?|undefined} */
    Org.prototype.change;
    /**
     * \@example Yukawa Systems GmbH
     * @type {?|undefined}
     */
    Org.prototype.companyName;
    /** @type {?|undefined} */
    Org.prototype.created;
    /**
     * \@example yukawa\@example.com
     * @type {?|undefined}
     */
    Org.prototype.email;
    /** @type {?|undefined} */
    Org.prototype.info;
    /**
     * \@example YUK
     * @type {?|undefined}
     */
    Org.prototype.orgId;
    /**
     * \@example +49 100 200 300
     * @type {?|undefined}
     */
    Org.prototype.phoneNumber;
    /**
     * \@example DE113344
     * @type {?|undefined}
     */
    Org.prototype.taxId;
    /**
     * \@example http://yukawa.de/
     * @type {?|undefined}
     */
    Org.prototype.website;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.org.OrgFilter <br/>
 * @record
 */
function OrgFilter() { }
if (false) {
    /** @type {?|undefined} */
    OrgFilter.prototype.addressFilter;
    /** @type {?|undefined} */
    OrgFilter.prototype.companyName;
    /** @type {?|undefined} */
    OrgFilter.prototype.email;
    /** @type {?|undefined} */
    OrgFilter.prototype.phoneNumber;
    /**
     * \@example DE113344
     * @type {?|undefined}
     */
    OrgFilter.prototype.taxId;
    /** @type {?|undefined} */
    OrgFilter.prototype.website;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.setting.Setting <br/>
 * @record
 */
function Setting() { }
if (false) {
    /** @type {?|undefined} */
    Setting.prototype.change;
    /**
     * \@example default central storage location
     * @type {?|undefined}
     */
    Setting.prototype.desc;
    /**
     * \@example main
     * @type {?|undefined}
     */
    Setting.prototype.module;
    /**
     * \@example Central Storage Location
     * @type {?|undefined}
     */
    Setting.prototype.name;
    /**
     * \@example YUK
     * @type {?|undefined}
     */
    Setting.prototype.orgId;
    /**
     * \@example storage.location.central
     * @type {?|undefined}
     */
    Setting.prototype.shortName;
    /**
     * \@example 1337
     * @type {?|undefined}
     */
    Setting.prototype.value;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.setting.SettingFilter <br/>
 * @record
 */
function SettingFilter() { }
if (false) {
    /**
     * \@example stock
     * @type {?|undefined}
     */
    SettingFilter.prototype.module;
    /**
     * \@example storage*
     * @type {?|undefined}
     */
    SettingFilter.prototype.shortName;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.Tag <br/>
 * @record
 */
function Tag() { }
if (false) {
    /** @type {?|undefined} */
    Tag.prototype.change;
    /** @type {?|undefined} */
    Tag.prototype.info;
    /** @type {?|undefined} */
    Tag.prototype.key;
    /**
     * \@example YUK
     * @type {?|undefined}
     */
    Tag.prototype.orgId;
    /** @type {?|undefined} */
    Tag.prototype.tagId;
    /** @type {?|undefined} */
    Tag.prototype.vocabularyId;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.TagFilter <br/>
 * @record
 */
function TagFilter() { }
/**
 * \@generator rest2ts
 * 	tag vocabulary <br/>
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.Vocabulary <br/>
 * @record
 */
function Vocabulary() { }
if (false) {
    /** @type {?|undefined} */
    Vocabulary.prototype.key;
    /** @type {?|undefined} */
    Vocabulary.prototype.vocabularyId;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.user.GroupContext <br/>
 * @record
 */
function GroupContext() { }
if (false) {
    /** @type {?|undefined} */
    GroupContext.prototype.groups;
    /** @type {?|undefined} */
    GroupContext.prototype.orgId;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.user.User <br/>
 * @record
 */
function User() { }
if (false) {
    /** @type {?|undefined} */
    User.prototype.account;
    /** @type {?|undefined} */
    User.prototype.change;
    /** @type {?|undefined} */
    User.prototype.created;
    /** @type {?|undefined} */
    User.prototype.defaultOrgId;
    /** @type {?|undefined} */
    User.prototype.groupContexts;
    /**
     * @deprecated
     * @type {?|undefined}
     */
    User.prototype.groups;
    /** @type {?|undefined} */
    User.prototype.orgIds;
    /** @type {?|undefined} */
    User.prototype.person;
    /**
     * \@example admin
     * @type {?|undefined}
     */
    User.prototype.username;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.user.UserFilter <br/>
 * @record
 */
function UserFilter() { }
if (false) {
    /** @type {?|undefined} */
    UserFilter.prototype.defaultOrgId;
    /** @type {?|undefined} */
    UserFilter.prototype.fields;
    /** @type {?|undefined} */
    UserFilter.prototype.groups;
    /** @type {?|undefined} */
    UserFilter.prototype.headers;
    /** @type {?|undefined} */
    UserFilter.prototype.orgIds;
    /** @type {?|undefined} */
    UserFilter.prototype.personFilter;
    /**
     * \@example admin
     * @type {?|undefined}
     */
    UserFilter.prototype.username;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.event.user.UserEvent <br/>
 * @record
 */
function UserEvent() { }

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UrlService = /** @class */ (function (_super) {
    __extends(UrlService, _super);
    function UrlService(configService, cfg) {
        if (cfg === void 0) { cfg = "baseUrl"; }
        return _super.call(this, cfg, configService) || this;
    }
    return UrlService;
}(UrlConfigService));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// noinspection JSUnusedGlobalSymbols
/**
 * inc.yukawa.chain.modules.main.core.MainRealm
 * \@since 2.0.7
 *
 */
var MainRealm = /** @class */ (function (_super) {
    __extends(MainRealm, _super);
    function MainRealm() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MainRealm.ROLE_MAIN_ADMIN = "ROLE_MAIN_ADMIN";
    MainRealm.ROLE_MAIN_EDIT = "ROLE_MAIN_EDIT";
    MainRealm.ROLE_MAIN_READ = "ROLE_MAIN_READ";
    MainRealm.ROLE_SYS_INFO = "ROLE_SYS_INFO";
    MainRealm.ROLE_USER_ADMIN = "ROLE_USER_ADMIN";
    MainRealm.ROLE_USER_EDIT = "ROLE_USER_EDIT";
    MainRealm.ROLE_USER_READ = "ROLE_USER_READ";
    MainRealm.ROLE_USER_INFO = "ROLE_USER_INFO";
    MainRealm.ROLE_USER_OWN = "ROLE_USER_OWN";
    MainRealm.ROLE_GROUP_ADMIN = "ROLE_GROUP_ADMIN";
    MainRealm.ROLE_GROUP_EDIT = "ROLE_GROUP_EDIT";
    MainRealm.ROLE_GROUP_READ = "ROLE_GROUP_READ";
    MainRealm.ROLE_MEMBERSHIP_ADMIN = "ROLE_MEMBERSHIP_ADMIN";
    MainRealm.ROLE_MEMBERSHIP_EDIT = "ROLE_MEMBERSHIP_EDIT";
    MainRealm.ROLE_MEMBERSHIP_READ = "ROLE_MEMBERSHIP_READ";
    MainRealm.ROLE_LABEL_ADMIN = "ROLE_LABEL_ADMIN";
    MainRealm.ROLE_LABEL_EDIT = "ROLE_LABEL_EDIT";
    MainRealm.ROLE_LABEL_READ = "ROLE_LABEL_READ";
    MainRealm.ROLE_ORG_ADMIN = "ROLE_ORG_ADMIN";
    MainRealm.ROLE_ORG_EDIT = "ROLE_ORG_EDIT";
    MainRealm.ROLE_ORG_READ = "ROLE_ORG_READ";
    MainRealm.ROLE_ORG_INFO = "ROLE_ORG_INFO";
    MainRealm.ROLE_ROLE_ADMIN = "ROLE_ROLE_ADMIN";
    MainRealm.ROLE_ROLE_EDIT = "ROLE_ROLE_EDIT";
    MainRealm.ROLE_ROLE_READ = "ROLE_ROLE_READ";
    MainRealm.ROLE_SETTING_ADMIN = "ROLE_SETTING_ADMIN";
    MainRealm.ROLE_SETTING_EDIT = "ROLE_SETTING_EDIT";
    MainRealm.ROLE_SETTING_READ = "ROLE_SETTING_READ";
    MainRealm.ROLE_TAG_ADMIN = "ROLE_TAG_ADMIN";
    MainRealm.ROLE_TAG_EDIT = "ROLE_TAG_EDIT";
    MainRealm.ROLE_TAG_READ = "ROLE_TAG_READ";
    return MainRealm;
}(BaseRealm));
if (false) {
    /** @type {?} */
    MainRealm.ROLE_MAIN_ADMIN;
    /** @type {?} */
    MainRealm.ROLE_MAIN_EDIT;
    /** @type {?} */
    MainRealm.ROLE_MAIN_READ;
    /** @type {?} */
    MainRealm.ROLE_SYS_INFO;
    /** @type {?} */
    MainRealm.ROLE_USER_ADMIN;
    /** @type {?} */
    MainRealm.ROLE_USER_EDIT;
    /** @type {?} */
    MainRealm.ROLE_USER_READ;
    /** @type {?} */
    MainRealm.ROLE_USER_INFO;
    /** @type {?} */
    MainRealm.ROLE_USER_OWN;
    /** @type {?} */
    MainRealm.ROLE_GROUP_ADMIN;
    /** @type {?} */
    MainRealm.ROLE_GROUP_EDIT;
    /** @type {?} */
    MainRealm.ROLE_GROUP_READ;
    /** @type {?} */
    MainRealm.ROLE_MEMBERSHIP_ADMIN;
    /** @type {?} */
    MainRealm.ROLE_MEMBERSHIP_EDIT;
    /** @type {?} */
    MainRealm.ROLE_MEMBERSHIP_READ;
    /** @type {?} */
    MainRealm.ROLE_LABEL_ADMIN;
    /** @type {?} */
    MainRealm.ROLE_LABEL_EDIT;
    /** @type {?} */
    MainRealm.ROLE_LABEL_READ;
    /** @type {?} */
    MainRealm.ROLE_ORG_ADMIN;
    /** @type {?} */
    MainRealm.ROLE_ORG_EDIT;
    /** @type {?} */
    MainRealm.ROLE_ORG_READ;
    /** @type {?} */
    MainRealm.ROLE_ORG_INFO;
    /** @type {?} */
    MainRealm.ROLE_ROLE_ADMIN;
    /** @type {?} */
    MainRealm.ROLE_ROLE_EDIT;
    /** @type {?} */
    MainRealm.ROLE_ROLE_READ;
    /** @type {?} */
    MainRealm.ROLE_SETTING_ADMIN;
    /** @type {?} */
    MainRealm.ROLE_SETTING_EDIT;
    /** @type {?} */
    MainRealm.ROLE_SETTING_READ;
    /** @type {?} */
    MainRealm.ROLE_TAG_ADMIN;
    /** @type {?} */
    MainRealm.ROLE_TAG_EDIT;
    /** @type {?} */
    MainRealm.ROLE_TAG_READ;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function GroupAspect() { }
if (false) {
    /**
     * @param {?} filter
     * @return {?}
     */
    GroupAspect.prototype.queryGroups = function (filter) { };
    /**
     * @param {?} key
     * @return {?}
     */
    GroupAspect.prototype.loadGroup = function (key) { };
    /**
     * @param {?} value
     * @return {?}
     */
    GroupAspect.prototype.createGroup = function (value) { };
    /**
     * @param {?} value
     * @return {?}
     */
    GroupAspect.prototype.editGroup = function (value) { };
    /**
     * @param {?} key
     * @return {?}
     */
    GroupAspect.prototype.deleteGroup = function (key) { };
}
/**
 * @record
 */
function UserAspect() { }
if (false) {
    /**
     * @deprecated
     * @param {?} filter
     * @return {?}
     */
    UserAspect.prototype.searchUser = function (filter) { };
    /**
     * @param {?} filter
     * @return {?}
     */
    UserAspect.prototype.queryUser = function (filter) { };
    /**
     * @param {?} id
     * @param {?} shortName
     * @return {?}
     */
    UserAspect.prototype.loadUser = function (id, shortName) { };
    /**
     * @param {?} user
     * @param {?} method
     * @return {?}
     */
    UserAspect.prototype.saveUser = function (user, method) { };
    /**
     * @param {?} id
     * @return {?}
     */
    UserAspect.prototype.deleteUser = function (id) { };
}
/**
 * @record
 */
function LabelAspect() { }
if (false) {
    /**
     * @param {?} filter
     * @return {?}
     */
    LabelAspect.prototype.findLabels = function (filter) { };
    /**
     * @param {?} filter
     * @return {?}
     */
    LabelAspect.prototype.queryLabel = function (filter) { };
    /**
     * @param {?} label
     * @return {?}
     */
    LabelAspect.prototype.createLabel = function (label) { };
}
/**
 * @record
 */
function SettingAspect() { }
if (false) {
    /**
     * @param {?} filter
     * @return {?}
     */
    SettingAspect.prototype.querySettings = function (filter) { };
    /**
     * @param {?} module
     * @param {?} shortName
     * @return {?}
     */
    SettingAspect.prototype.loadSetting = function (module, shortName) { };
    /**
     * @param {?} Setting
     * @return {?}
     */
    SettingAspect.prototype.editSetting = function (Setting) { };
    /**
     * @param {?} module
     * @param {?} shortName
     * @return {?}
     */
    SettingAspect.prototype.deleteSetting = function (module, shortName) { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { MainRealm, UrlService };
//# sourceMappingURL=yukawa-chain-main-angular-core.js.map
